#! /bin/bash
##########################################################
# This script IS NOW COMPLETELY OBSOLETE !!!! DO NOT USE IT
# use the option -subpageno number|all of xawdecode
##########################################################
#
# display teletext subtitles in xawdecode
# required: xawdecode_alevt-cap, xawdecode_cmd
# (copied from the xawtv version)

##########################################################

# config
charset="latin-1"
devvbi="/dev/vbi0"
wizard="no"

# -- check kernel version
kernel26=`uname -r | grep 2.6.`
#-- search for the good vbi device (from calimero xawdecode_scantv.sh)
if [ "$kernel26" = "" ]; then # KERNEL 2.4.x
   i=0
   trouve=""
   while [ $i -le 9 ] && [ "$trouve" = "" ]; do
      if [ -e "/proc/video/dev/vbi${i}" ]; then
         vbi=`cat /proc/video/dev/vbi${i} | grep vbi`
      fi
      [ "$vbi" != "" ] && trouve="OK"
      i=$(($i+1))    
   done
   i=$(($i-1))
else # KERNEL 2.6.x
   i=0
   trouve=""
   while [ $i -le 9 ] && [ "$trouve" = "" ]; do
      if [ -e "/sys/class/video4linux/vbi${i}" ]; then
         vbi=`cat /sys/class/video4linux/vbi${i}/name | grep vbi`
      fi
      [ "$vbi" != "" ] && trouve="OK"
      i=$(($i+1))
   done
   i=$(($i-1))
fi
if [ "$trouve" = "OK" ] ; then
   if [ -e /dev/v4l/vbi${i} ]; then
      devvbi="/dev/v4l/vbi${i}"
   elif [ -e /dev/vbi${i} ]; then
      devvbi="/dev/vbi${i}"
   else
      echo "Autodetection: Vbi device missing..."
      echo "Vbi used will be:$devvbi"
   fi
else
   echo "Autodetection: Vbi device not found..."
   echo "Vbi used will be:$devvbi"
fi
echo "-->Autodetection: Vbi device found : $devvbi"
#---

##########################################################
# helpers

function usage() {
cat <<EOF
This script displays teletext subtitles within xawdecode.
It needs the xawdecode_alevt-cap and xawdecode_cmd utilities.
And you must run "xawdecode -novbi".

usage: `basename $0` [ options ] <pagenr>
   <pagenr> is the teletext page which is used for the
   subtitles. In germany it is usually page 150, in france 888 or 889.

options:
   -help                this text
   -charset <charset>   latin-1/2 (default: $charset)
   -vbi <dev>           vbi device (default: $device)
   -wizard		to use easily this script with xawdecode_wizard
EOF
}

##########################################################
# parse args

done=0
while test "$done" = "0"; do
	case "$1" in
		-h | -help | --help)
			usage
			exit 0
			;;
		-charset)
			charset="$2"
			shift; shift
			;;
		-vbi)
			device="$2"
			shift; shift
			;;
		-wizard)
			wizard="yes"
			shift; shift
			;;
		-*)
			echo "unknown option: $1, try -h for help"
			exit 1
			;;
		*)
			page="$1"
			done=1
			;;
	esac
done

if test "$wizard" = "yes"; then
   echo -n "Which teletext page do you want to read [ by default : 888 ] ? > "
   read page
      if [ "$page" = "" ]; then
      echo "ok, we use default page : 888 "
      page=888
      fi
fi

if test "$page" = ""; then
	usage
	exit 1
fi

##########################################################
# main loop

echo "displaying subtitles, using page $page"
echo "hit ^C to exit"
trap "xawdecode_cmd vtx" EXIT
while true; do
	PAGE="$(xawdecode_alevt-cap -format ascii \
		-charset $charset -vbi $devvbi		\
		-name /dev/stdout $page | tail -22 \
               | tr ';' ' ' | tr '\n' '|')"
	xawdecode_cmd "vtx $PAGE"
done
